-- name: [CS] HONEYQUEEN WIP
-- description: The best racer from Mario Kart 7! \n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!



local E_MODEL_HONEYQUEEN = smlua_model_util_get_id("honeyqueen_geo")

local TEX_HONEYQUEEN = get_texture_info("honeyqueen_icon")

local TEXT_MOD_NAME = "[CS] HONEYQUEEN"

local VOICETABLE_HONEYQUEEN = {
    [CHAR_SOUND_ATTACKED] = 'CHAR_SOUND_ATTACKED.ogg',
    [CHAR_SOUND_COUGHING1] = 'CHAR_SOUND_COUGHING1.ogg',
    [CHAR_SOUND_COUGHING2] = 'CHAR_SOUND_COUGHING2.ogg',
    [CHAR_SOUND_COUGHING3] = 'CHAR_SOUND_COUGHING3.ogg',
    [CHAR_SOUND_DOH] = {'CHAR_SOUND_DOH.ogg'},
    [CHAR_SOUND_DROWNING] = 'CHAR_SOUND_DROWNING.ogg',
    [CHAR_SOUND_DYING] = 'CHAR_SOUND_DYING.ogg',
    [CHAR_SOUND_EEUH] = 'CHAR_SOUND_EEUH.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'CHAR_SOUND_GROUND_POUND_WAH.ogg',
    [CHAR_SOUND_HAHA] = 'CHAR_SOUND_HAHA.ogg',
    [CHAR_SOUND_HAHA_2] = 'CHAR_SOUND_HAHA_2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'CHAR_SOUND_HERE_WE_GO.ogg',
    [CHAR_SOUND_HOOHOO] = 'CHAR_SOUND_HOOHOO.ogg',
    [CHAR_SOUND_HRMM] = 'CHAR_SOUND_HRMM.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'CHAR_SOUND_IMA_TIRED.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'CHAR_SOUND_MAMA_MIA.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'CHAR_SOUND_LETS_A_GO.ogg',
    [CHAR_SOUND_ON_FIRE] = 'CHAR_SOUND_ON_FIRE.ogg',
    [CHAR_SOUND_OOOF] = 'CHAR_SOUND_OOOF.ogg',
    [CHAR_SOUND_OOOF2] = 'CHAR_SOUND_OOOF2.ogg',
    [CHAR_SOUND_PANTING] = 'CHAR_SOUND_PANTING.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'CHAR_SOUND_PANTING.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'CHAR_SOUND_PUNCH_HOO.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'CHAR_SOUND_PUNCH_WAH.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'CHAR_SOUND_PUNCH_YAH.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'CHAR_SOUND_SO_LONGA_BOWSER.ogg',
    [CHAR_SOUND_SNORING1] = 'CHAR_SOUND_SNORING1.ogg',
    [CHAR_SOUND_SNORING2] = 'CHAR_SOUND_SNORING2.ogg',
    [CHAR_SOUND_SNORING3] = 'CHAR_SOUND_SNORING3.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'CHAR_SOUND_TWIRL_BOUNCE.ogg',
    [CHAR_SOUND_UH] = 'CHAR_SOUND_UH.ogg',
    [CHAR_SOUND_UH2] = 'CHAR_SOUND_UH2.ogg',
    [CHAR_SOUND_UH2_2] = 'CHAR_SOUND_UH2_2.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'CHAR_SOUND_WAAAOOOW.ogg',
    [CHAR_SOUND_WAH2] = 'CHAR_SOUND_WAH2.ogg',
    [CHAR_SOUND_WHOA] = 'CHAR_SOUND_WHOA.ogg',
    [CHAR_SOUND_YAHOO] = 'CHAR_SOUND_YAHOO.ogg',
    [CHAR_SOUND_YAWNING] = 'CHAR_SOUND_YAWNING.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg', 'CHAR_SOUND_YAHOO_WAHA_YIPPEE.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'CHAR_SOUND_YAH_WAH_HOO.ogg','CHAR_SOUND_YAH_WAH_HOO.ogg'}
    }

local capHONEYQUEEN = {
    normal = smlua_model_util_get_id("honeyqueen_cap_geo"),
    wing = smlua_model_util_get_id("honeyqueen_wing_cap_geo"),
    metal = smlua_model_util_get_id("honeyqueen_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("honeyqueen_metal_wing_cap_geo")
}

local PALETTE_HONEYQUEEN = {
    [SHIRT] = "FDD01E",
    [SHOES] = "ffffff",
    [HAIR] = "9A513F",
    [CAP] = "DA5990",
    [PANTS] = "8838B8",
    [GLOVES] = "ffffff",
    [SKIN] = "ffffff",
    [EMBLEM] = "44EEFF",
}

local PM_HONEYQUEEN = {
    label = {
        left = get_texture_info("honeyqueen_pm1"),
        right = get_texture_info("honeyqueen_pm2"),
    },
    pie = {
        [1] = get_texture_info("PM-1"),
        [2] = get_texture_info("PM-2"),
        [3] = get_texture_info("PM-3"),
        [4] = get_texture_info("PM-4"),
        [5] = get_texture_info("PM-5"),
        [6] = get_texture_info("PM-6"),
        [7] = get_texture_info("PM-7"),
        [8] = get_texture_info("PM-8"),

    }
}

local TEX_FLYPM0 = get_texture_info("fly_pm0")
local TEX_FLYPM1 = get_texture_info("fly_pm1")
local TEX_FLYPM2 = get_texture_info("fly_pm2")
local TEX_FLYPM3 = get_texture_info("fly_pm3")
local TEX_FLYPM4 = get_texture_info("fly_pm4")
local TEX_FLYPM5 = get_texture_info("fly_pm5")
local TEX_FLYPM6 = get_texture_info("fly_pm6")
local TEX_FLYPM7 = get_texture_info("fly_pm7")
local TEX_FLYPM8 = get_texture_info("fly_pm8")

local honeyqueenAnims = {
    [CHAR_ANIM_BEND_KNESS_RIDING_SHELL] = 'honeyqueen_fly_idle',
    [CHAR_ANIM_FAST_LEDGE_GRAB] = 'honeyqueen_fast_ledge_grab',
    [CHAR_ANIM_IDLE_ON_LEDGE] = 'honeyqueen_ledgeidle',
    [CHAR_ANIM_CLIMB_DOWN_LEDGE] = 'honeyqueen_climbdownledge',
    [CHAR_ANIM_SLOW_LEDGE_GRAB] = 'honeyqueen_slow_ledge_grab',

}

---@type integer
gPlayerSyncTable[0].honeyqueenFlight = 0
gPlayerSyncTable[1].honeyqueenFlight = 0
gPlayerSyncTable[2].honeyqueenFlight = 0
gPlayerSyncTable[3].honeyqueenFlight = 0
gPlayerSyncTable[4].honeyqueenFlight = 0
gPlayerSyncTable[5].honeyqueenFlight = 0
gPlayerSyncTable[6].honeyqueenFlight = 0
gPlayerSyncTable[7].honeyqueenFlight = 0
gPlayerSyncTable[8].honeyqueenFlight = 0
gPlayerSyncTable[9].honeyqueenFlight = 0
gPlayerSyncTable[10].honeyqueenFlight = 0
gPlayerSyncTable[11].honeyqueenFlight = 0
gPlayerSyncTable[12].honeyqueenFlight = 0
gPlayerSyncTable[13].honeyqueenFlight = 0
gPlayerSyncTable[14].honeyqueenFlight = 0
gPlayerSyncTable[15].honeyqueenFlight = 0

local flight_tbl =
{
    [0] = TEX_FLYPM8,
    [1] = TEX_FLYPM7,
    [2] = TEX_FLYPM6,
    [3] = TEX_FLYPM5,
    [4] = TEX_FLYPM4,
    [5] = TEX_FLYPM3,
    [6] = TEX_FLYPM2,
    [7] = TEX_FLYPM1,
    [8] = TEX_FLYPM0,
}
ACT_HONEYQUEENFLIGHT = allocate_mario_action(ACT_GROUP_AIRBORNE |  ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | AIR_STEP_CHECK_LEDGE_GRAB)


if _G.charSelectExists then
    CT_HONEYQUEEN = _G.charSelect.character_add("Honey Queen",
        "The large Queen of the Bees! Her Stinger packs a punch! She can buzz around after a jump! Voiced by GauntletQueen", "Melzinoff, wibblus & GauntletQueen",
        { r = 255, g = 200, b = 200 }, E_MODEL_HONEYQUEEN, CT_MARIO, TEX_HONEYQUEEN)

    _G.charSelect.character_add_caps(E_MODEL_HONEYQUEEN, capHONEYQUEEN)

    _G.charSelect.character_add_palette_preset(E_MODEL_HONEYQUEEN, PALETTE_HONEYQUEEN)

    _G.charSelect.character_add_health_meter(CT_HONEYQUEEN, PM_HONEYQUEEN)

    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_HONEYQUEEN, VOICETABLE_HONEYQUEEN)

    

    function act_Honeyqueenflight(m)
        
        common_air_action_step(m, ACT_DOUBLE_JUMP_LAND, CHAR_ANIM_BEND_KNESS_RIDING_SHELL, AIR_STEP_NONE)
        
        if m.forwardVel > 17 then
            mario_set_forward_vel(m, 17)
        end
        local forward = coss(abs_angle_diff(m.faceAngle.y + 0x8000, m.intendedYaw)) * m.intendedMag
        local side = coss(abs_angle_diff(m.faceAngle.y + 0x4000, m.intendedYaw)) * m.intendedMag

        local angle = m.marioObj.header.gfx.angle

        angle.x = approach_s16_asymptotic(m.actionState, forward * -100, 8)
        angle.z = approach_s16_asymptotic(m.actionTimer, side * -120, 8)

        m.actionState = angle.x
        m.actionTimer = angle.z

        m.vel.y = m.vel.y + 2.5
        m.marioBodyState.wingFlutter = 0
        if (m.controller.buttonDown & A_BUTTON) ~= 0 and (gPlayerSyncTable[m.playerIndex].honeyqueenFlight <= 80) then
            
            gPlayerSyncTable[m.playerIndex].honeyqueenFlight = gPlayerSyncTable[m.playerIndex].honeyqueenFlight + 1
            m.vel.y = approach_f32(5.5, 5.5, 6.0, 3.0)

            m.marioBodyState.wingFlutter = 1
            
        end
        if (m.controller.buttonPressed & Z_TRIG) ~= 0 then
            set_mario_action(m, ACT_GROUND_POUND, 0)
        end
        if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
            set_mario_action(m, ACT_DIVE, 0)
        end
    end

    ---@param m MarioState
    function mario_update(m)
        if gPlayerSyncTable[m.playerIndex].honeyqueenplayer then
            -- Honey Flight
            if gPlayerSyncTable[m.playerIndex].honeyqueenFlight < 0 then
                gPlayerSyncTable[m.playerIndex].honeyqueenFlight = 0
            end
            if gPlayerSyncTable[m.playerIndex].honeyqueenFlight <= 80 then
                if (m.controller.buttonDown & A_BUTTON) ~= 0 and m.vel.y < -15 then
                    if (m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_WALL_KICK_AIR) then
                        set_mario_action(m, ACT_HONEYQUEENFLIGHT, 0)
                        play_character_sound(m, CHAR_SOUND_HAHA)
                    end
                end
            end

            --reset the bool to float more than once in a server lol
            if (m.playerIndex == 0) then
            if m.action == ACT_JUMP_LAND or m.action == ACT_DOUBLE_JUMP_LAND or m.action == ACT_TRIPLE_JUMP_LAND or m.action == ACT_IDLE or m.action == ACT_WALKING or m.action == ACT_HOLDING_POLE then
                if gPlayerSyncTable[m.playerIndex].honeyqueenFlight > 0 then
                    gPlayerSyncTable[m.playerIndex].honeyqueenFlight = gPlayerSyncTable[m.playerIndex].honeyqueenFlight -
                    2
                end
            end
        end
        end


        local animID = m.marioObj.header.gfx.animInfo.animID

        -- replaced animations
        local luaAnimID = honeyqueenAnims[animID]
        if luaAnimID then
            -- if the current anim ID has a valid lua anim ID associated with it, play the custom animation
            smlua_anim_util_set_animation(m.marioObj, luaAnimID)
        end
    end

    ---@param m MarioState
    ---@param o Object
    --sets what happens when a character picks up a coin
    function honeyqueenCoinGet(m, o, interactType)
        if (m.playerIndex == 0) then
            if interactType == INTERACT_COIN and (o.oDamageOrCoinValue > 0) then --checking that a coin was interacted with
                if gPlayerSyncTable[0].honeyqueenFlight > 0 then
                    gPlayerSyncTable[0].honeyqueenFlight = gPlayerSyncTable[0].honeyqueenFlight- (o.oDamageOrCoinValue*10)
                end
            end
        end
    end

    function on_pvp_attack(attacker, victim)
        if victim.playerIndex == 0 then
            if (attacker.action == ACT_GROUND_POUND) then
                victim.hurtCounter = 16
            end
        end
    end

    hook_event(HOOK_UPDATE, function()
        -- flag to determine if a player is daisy (boolean)
        -- this is done in the local update hook because character select can only check for the local player's numbers
        -- gPlayerSyncTable auto syncs the result to all clients
        gPlayerSyncTable[0].honeyqueenplayer = (_G.charSelect.character_get_current_number() == CT_HONEYQUEEN)
    end)


    local openTimer = 0 -- ranges 0 -> OPEN_LENGTH
    local OPEN_LENGTH = 15
    local prevY = -djui_hud_get_screen_height() / 1.025


    function on_hud_render()
        
        if gPlayerSyncTable[0].honeyqueenplayer then
            djui_hud_set_resolution(RESOLUTION_N64)
            local height = djui_hud_get_screen_height()
            local width = djui_hud_get_screen_width()
            local startpoint = -height / 1.025
            local destpoint = height - height / 1.025
            local x = width/1.565

            local y = startpoint + (destpoint - startpoint) * math.sqrt(openTimer / OPEN_LENGTH)

            local tex = flight_tbl[gPlayerSyncTable[0].honeyqueenFlight//10]

            if tex then
            djui_hud_render_texture_interpolated(tex, x, prevY, 1, 1 ,x, y, 1, 1)
            end
            --djui_hud_render_texture(flight_tbl[gPlayerSyncTable[0].honeyqueenFlight // 10], width / 1.75, y, 1, 1)

            prevY = y
        end
    end




  --[[  hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
        if gMarioStates[0].area == nil or gMarioStates[0].area.camera ==nil then return end
        if gPlayerSyncTable[0].honeyqueenFlight > 0 then
            openTimer = min(openTimer + 1, OPEN_LENGTH)
            on_hud_render()
        elseif openTimer > 0 then
            openTimer = openTimer - 1
            on_hud_render()
        end
    end)
]]
    _G.charSelect.character_hook_moveset(CT_HONEYQUEEN, HOOK_MARIO_UPDATE, mario_update)
    _G.charSelect.character_hook_moveset(CT_HONEYQUEEN, HOOK_ON_PVP_ATTACK, on_pvp_attack)
    _G.charSelect.character_hook_moveset(CT_HONEYQUEEN, HOOK_ON_HUD_RENDER_BEHIND, function()
        if gMarioStates[0].area == nil or gMarioStates[0].area.camera ==nil then return end
        if gPlayerSyncTable[0].honeyqueenFlight > 0 then
            openTimer = min(openTimer + 1, OPEN_LENGTH)
            on_hud_render()
        elseif openTimer > 0 then
            openTimer = openTimer - 1
            on_hud_render()
        end
    end)
    _G.charSelect.character_hook_moveset(CT_HONEYQUEEN, HOOK_ON_INTERACT, honeyqueenCoinGet)
    --hook_event(HOOK_ON_INTERACT, honeyqueenCoinGet)
    --hook_event(HOOK_MARIO_UPDATE, mario_update)
    --hook_event(HOOK_ON_PVP_ATTACK, on_pvp_attack)

    hook_mario_action(ACT_HONEYQUEENFLIGHT, { every_frame = act_Honeyqueenflight })

    hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_HONEYQUEEN then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function(m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_HONEYQUEEN then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create(
    "\\#ffffdc\\\n" ..
    TEXT_MOD_NAME ..
    "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
end
